<?php

namespace Daylight\Core\Models;

use Daylight\Core\Models\Translations\OptionTranslation;
use Daylight\Core\Modules\Multilingualism\Contracts\HasTranslations;
use Daylight\Core\Modules\Multilingualism\Models\Concerns\InteractsWithTranslations;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Option extends Model implements HasTranslations
{
    use InteractsWithTranslations;

    protected $guarded = [];

    public function translatedFields(): array
    {
        return ['name'];
    }

    public function values(): HasMany
    {
        return $this->hasMany(OptionValue::class);
    }

    public function translations(): HasMany
    {
        return $this->hasMany(OptionTranslation::class);
    }

    public function defaultTranslation(): HasOne
    {
        return $this
            ->hasOne(OptionTranslation::class)
            ->where('locale', config('multilingualism.default_locale'));
    }
}
